// DlgPixelMapSubForm.cpp :  Դϴ.
//

#include "stdafx.h"
#include "TestBase01.h"
#include "DlgFixturePage.h"
#include ".\dlgfixturepage.h"


// CDlgPixelMapSubForm ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgFixturePage, CDialog)
CDlgFixturePage::CDlgFixturePage(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgFixturePage::IDD, pParent)
	, m_FixtureTotalPixels(0)
	, m_FixtureHorizontalPixels(0)
	, m_FixtureVerticalPixels(0)
	, m_FixtureSymbolWidth(0)
	, m_FixtureSymbolHeight(0)
	, m_FixtureLength(0)
	, m_FixturePortAndSequence(_T(""))
	, m_FixtureOriginX(0)
	, m_FixtureOriginY(0)
	, m_FixtureType(_T(""))
{
	g_DlgFixturePage = this;
}

CDlgFixturePage::~CDlgFixturePage()
{
}

void CDlgFixturePage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_STATIC_FIXTURE_TOTALPIXELS, m_FixtureTotalPixels);
	DDX_Text(pDX, IDC_STATIC_FIXTURE_HORIZONTALPIXELS, m_FixtureHorizontalPixels);
	DDX_Text(pDX, IDC_STATIC_FIXTURE_VERTICALPIXELS, m_FixtureVerticalPixels);
	DDX_Text(pDX, IDC_STATIC_FIXTURE_SYMBOLWIDTH, m_FixtureSymbolWidth);
	DDX_Text(pDX, IDC_STATIC_FIXTURE_SYMBOLHEIGHT, m_FixtureSymbolHeight);
	DDX_Text(pDX, IDC_STATIC_FIXTURE_LENGTH, m_FixtureLength);
	DDX_Text(pDX, IDC_STATIC_FIXTURE_PORTANDSEQUENCE, m_FixturePortAndSequence);
	DDX_Text(pDX, IDC_EDIT_FIXTURE_ORIGINX, m_FixtureOriginX);
	DDX_Text(pDX, IDC_EDIT_FIXTURE_ORIGINY, m_FixtureOriginY);
	DDX_Control(pDX, IDC_LIST_FIXTURE_PIXELS, m_FixtureFixturePixelsList);
	DDX_Text(pDX, IDC_STATIC_FIXTURE_TYPE, m_FixtureType);
}


BEGIN_MESSAGE_MAP(CDlgFixturePage, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_WM_ERASEBKGND()
	ON_WM_DESTROY()
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_FIXTURE_ORIGINSPINX, OnDeltaposSpinFixtureOriginspinx)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_FIXTURE_ORIGINSPINY, OnDeltaposSpinFixtureOriginspiny)
END_MESSAGE_MAP()


// CDlgPixelMapSubForm ޽ óԴϴ.

BOOL CDlgFixturePage::Create(CWnd* pParentWnd)
{
	return CDialog::Create(IDD, pParentWnd);
}

void CDlgFixturePage::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
//	OnOK();
}

void CDlgFixturePage::OnBnClickedCancel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
//	OnCancel();
}

BOOL CDlgFixturePage::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	return CDialog::OnEraseBkgnd(pDC);
}

void CDlgFixturePage::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}

BOOL CDlgFixturePage::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ⿡ ߰ ʱȭ ۾ ߰մϴ.

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CDlgFixturePage::OnDeltaposSpinFixtureOriginspinx(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	// ó
	// pNMUpDown->iDelta   ΰ  ΰ Ǻؼ   Ѵ.
	//    iDelta    ʴ´.

	if(pNMUpDown->iDelta < 0)
		FixtureArray::GetInstance().CurChangeFixturePosX(true);
	else
		FixtureArray::GetInstance().CurChangeFixturePosX(false);

	*pResult = 0;
}

void CDlgFixturePage::OnDeltaposSpinFixtureOriginspiny(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	// ó
	// pNMUpDown->iDelta   ΰ  ΰ Ǻؼ   Ѵ.
	//    iDelta    ʴ´.

	if(pNMUpDown->iDelta < 0)
		FixtureArray::GetInstance().CurChangeFixturePosY(true);
	else
		FixtureArray::GetInstance().CurChangeFixturePosY(false);

	*pResult = 0;
}
