// DlgLinearFixtureSetup.cpp :  Դϴ.
//

#include "stdafx.h"
#include "TestBase01.h"
#include "DlgLinearFixtureSetup.h"
#include ".\dlglinearfixturesetup.h"


// CDlgLinearFixtureSetup ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgLinearFixtureSetup, CDialog)
CDlgLinearFixtureSetup::CDlgLinearFixtureSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLinearFixtureSetup::IDD, pParent)
	, m_LfsName(_T(""))
	, m_LfsPixels(0)
	, m_LfsLength(0)
{
	name = "none";
	pixels = 1;
	symbollength = 1;
	color = 0;

	modifymode = LINEARMODE_ADD;
}

CDlgLinearFixtureSetup::~CDlgLinearFixtureSetup()
{
}

void CDlgLinearFixtureSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_LFS_NAME, m_LfsName);
	DDX_Text(pDX, IDC_EDIT_LFS_PIXELS, m_LfsPixels);
	DDX_Text(pDX, IDC_EDIT_LFS_LENGTH, m_LfsLength);
}


BEGIN_MESSAGE_MAP(CDlgLinearFixtureSetup, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BTN_LFS_COLOR, OnBnClickedBtnLfsColor)
	ON_EN_CHANGE(IDC_EDIT_LFS_PIXELS, OnEnChangeEditLfsPixels)
END_MESSAGE_MAP()


// CDlgLinearFixtureSetup ޽ óԴϴ.

BOOL CDlgLinearFixtureSetup::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  Ų.
	m_LfsName = name;
	m_LfsPixels = pixels;
	m_LfsLength = symbollength;	

	if(modifymode == LINEARMODE_MODIFY) {
		//  . ̸ ٲܼ .
		GetDlgItem(IDC_EDIT_LFS_NAME)->EnableWindow(FALSE);
	}

	//   ǵ Ѵ.
	GetDlgItem(IDC_EDIT_LFS_LENGTH)->EnableWindow(FALSE);

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CDlgLinearFixtureSetup::OnBnClickedOk()
{
	//  Ʈ ϰ Ѱ ֱ ؼ  Ѵ.
	UpdateData();
	name = m_LfsName;
/*
	pixels = m_LfsPixels;
	symbollength = m_LfsLength;
*/

	pixels = m_LfsPixels;
	symbollength = m_LfsPixels;
	
	OnOK();
}

void CDlgLinearFixtureSetup::OnBnClickedCancel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	OnCancel();
}

void CDlgLinearFixtureSetup::OnBnClickedBtnLfsColor()
{
	//color
}

void CDlgLinearFixtureSetup::OnEnChangeEditLfsPixels()
{
	// TODO:  RICHEDIT Ʈ   Ʈ
	// CDialog::ũ OR Ͽ  ENM_CHANGE ÷׸ Ͽ
	// CRichEditCtrl().SetEventMask() ȣϵ OnInitDialog() Լ  
	//  ˸  ʽϴ.

	UpdateData(TRUE);

	m_LfsLength = m_LfsPixels;

	UpdateData(FALSE);
}
