#pragma once
#include "afxwin.h"
#include "afxcmn.h"

#include "DlgFixturePage.h"
#include "DlgSequencePage.h"
#include "DlgPixelListPage.h"


//////////////////////////////////////////////////////////////////////////
// CDlgPixelMapPage ȭ Դϴ.

class CDlgPixelMapPage : public CDialog
{
	DECLARE_DYNAMIC(CDlgPixelMapPage)

public:
	CDlgPixelMapPage(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~CDlgPixelMapPage();

	// ȭ  Դϴ.
	enum { IDD = IDD_DLG_PIXELMAP };

public:
	//
	CDlgPixelMapToolBox		m_PixelMapToolBox;
	//
	CPixelMapView*			m_pPixelMapView;
	//
	CDlgFixturePage			m_FixturePage;
	CDlgSequencePage		m_SequencePage;
	CDlgPixelListPage		m_PixelListPage;

public:
	//   Ӽ ߰
	void AddTabMain();
	//   Ʈ  
	void ResizeTabMain();

	// ȭ 
	void GetResizeSubDlg(CDialog* pDlg);
	void ShowFixturePage(BOOL isShow);
	void ShowSequencePage(BOOL isShow);
	void ShowPixelListPage(BOOL isShow);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL Create(CWnd* pParentWnd = NULL);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	CTabCtrl m_tbPixelMapSubForm;
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnNcDestroy();
	afx_msg void OnDestroy();
	afx_msg void OnNMClickPixelmapTbSubform(NMHDR *pNMHDR, LRESULT *pResult);
};
