// DlgSequencePage.cpp :  Դϴ.
//

#include "stdafx.h"
#include "TestBase01.h"
#include "DlgProgrammingPage.h"
#include ".\dlgprogrammingpage.h"


// CDlgSequencePage ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgProgrammingPage, CDialog)
CDlgProgrammingPage::CDlgProgrammingPage(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgProgrammingPage::IDD, pParent)
{
	g_DlgProgrammingPage = this;

	m_pCurImage = NULL;
	m_pProgrammingView = NULL;
}

CDlgProgrammingPage::~CDlgProgrammingPage()
{
}

void CDlgProgrammingPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_IMAGELIST, m_ImageList);
}


BEGIN_MESSAGE_MAP(CDlgProgrammingPage, CDialog)
	ON_WM_ERASEBKGND()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_NOTIFY(LVN_DELETEALLITEMS, IDC_LIST_IMAGELIST, OnLvnDeleteallitemsListImagelist2)
	ON_NOTIFY(NM_CLICK, IDC_LIST_IMAGELIST, OnNMClickListImagelist2)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_BTN_ADD, OnBnClickedBtnAdd)
	ON_BN_CLICKED(IDC_BTN_DELETE, OnBnClickedBtnDelete)
	ON_BN_CLICKED(IDC_BTN_DELETEALL, OnBnClickedBtnDeleteall)
END_MESSAGE_MAP()


// CDlgSequencePage ޽ óԴϴ.
int GetTypeFromFileName(CString& str)
{
	CString fileName = str;
	CString ext3=fileName.Right(3);
	CString ext4=fileName.Right(4);
#if CXIMAGE_SUPPORT_PNG
	if(ext3.CompareNoCase(_T("png"))==0)
		return CXIMAGE_FORMAT_PNG;
#endif
#if CXIMAGE_SUPPORT_BMP
	else if(ext3.CompareNoCase(_T("bmp"))==0)
		return CXIMAGE_SUPPORT_BMP;
#endif
#if CXIMAGE_SUPPORT_JPG
	else if(ext3.CompareNoCase(_T("jpg"))==0)
		return CXIMAGE_SUPPORT_JPG;
#endif

	return CXIMAGE_FORMAT_UNKNOWN;
}

// CxImage ü ϰ ̹ εĿ ListCtrl    ִ Լ
// ̹ ߸ Ǿų ε   Null ߻Ѵ.
CxImage* CDlgProgrammingPage::GetImage(CString& strPath)
{
	int nImageType=GetTypeFromFileName(strPath);
	if(nImageType==CXIMAGE_FORMAT_UNKNOWN) {
		MessageBox("ش    ϴ.", "", MB_OK);
		return NULL;
	}

	CxImage* pImg = new CxImage(strPath, nImageType);

	if(pImg->IsValid() == false) {
		delete pImg;

		MessageBox("ش    ϴ.", "", MB_OK);
		return NULL;
	}

	return pImg;
}

void CDlgProgrammingPage::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
//	OnOK();
}

void CDlgProgrammingPage::OnBnClickedCancel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
//	OnCancel();
}

BOOL CDlgProgrammingPage::Create(CWnd* pParentWnd)
{
	return CDialog::Create(IDD, pParentWnd);
}

BOOL CDlgProgrammingPage::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	return TRUE;
//	return CDialog::OnEraseBkgnd(pDC);
}

BOOL CDlgProgrammingPage::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Programming  
	CCreateContext pContext;
	CWnd* pFrameWnd = this;

	pContext.m_pCurrentDoc = new CDummyDoc();
	pContext.m_pNewViewClass = RUNTIME_CLASS(CProgrammingView);
	m_pProgrammingView = (CProgrammingView *) ((CFrameWnd*)pFrameWnd)->CreateView(&pContext);
	ASSERT(m_pProgrammingView);
	m_pProgrammingView->ShowWindow(SW_NORMAL);
	m_pProgrammingView->OnInitialUpdate();

	//   Ʈ  
	ResizeTabMain();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CDlgProgrammingPage::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	//   Ʈ  
	ResizeTabMain();
}

//   Ʈ  
void CDlgProgrammingPage::ResizeTabMain()
{
	if(!m_pProgrammingView) 
		return;

	CRect rect, rect2, rect3;
	GetClientRect(&rect);

	rect.left = 206;
	rect.top = 40;

	// ʿ ٴ 
	m_pProgrammingView->SetWindowPos(NULL, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, SWP_FRAMECHANGED);
}

void CDlgProgrammingPage::OnLvnDeleteallitemsListImagelist2(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	// lparam ߱  Ҹɶ ü    Ѵ.
	// ̰ ָ ޸  ߻
	OnBnClickedBtnDeleteall();

	*pResult = 0;
}

void CDlgProgrammingPage::OnNMClickListImagelist2(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	m_CurSelIndex = pNMLV->iItem;
	CString data = m_ImageList.GetItemText(m_CurSelIndex, 0);

	//  Ǿ  ȭ Ʈ Ѵ.
	if(m_CurSelIndex == -1) 
		return;

	// θ  ´.
	CString* pFullPath = (CString*)m_ImageList.GetItemData(m_CurSelIndex);

	// ̹   ´.
	// ⼭  ̹ new ؼ ޸𸮿  ̹Դϴ.
	m_pCurImage = GetImage(*pFullPath);
	if(m_pCurImage) {
 		g_ProgrammingView->SetImage(m_pCurImage);
// 
// 		 ̰ ؼ.. 
// 		Symbol  ؼ Color Ѵ.
// 		ϳϳ   ؾ ϴ κε ϴ.
// 		. Ʈ ϰ 1ܰ  .

//		CPaintDC dc(this);

//		m_pCurImage->Draw(dc.m_hDC, 
	}

	*pResult = 0;
}
void CDlgProgrammingPage::OnBnClickedBtnAdd()
{
	static char BASED_CODE szFilter[] = "Bitmap Files (*.bmp)|*.bmp|All Files (*.*)|*.*|";
	CFileDialog dlg(TRUE, _T("*.bmp"), _T("*.bmp"), OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
	//⺻ θ Ѵ.
	dlg.m_ofn.lpstrInitialDir = "";

	if(dlg.DoModal() == IDOK)
	{
		//  о 
		CString pullPath = dlg.GetPathName();
		//  ߰ϱ
		int index = m_ImageList.GetItemCount();

		// θ ޸𸮿 ߰ Ŀ  ´.
		CString* pPath = new CString(pullPath);
		m_ImageList.InsertItem(LVIF_TEXT | LVIF_PARAM, index, dlg.GetFileName(), 0, 0, 0, (LPARAM)pPath);
	}
}

void CDlgProgrammingPage::OnBnClickedBtnDelete()
{
	if(m_CurSelIndex >= 0 && m_CurSelIndex < m_ImageList.GetItemCount()) {
		CString* pFullPath = (CString*)m_ImageList.GetItemData(m_CurSelIndex);
		SAFE_DELETE(pFullPath);

		m_ImageList.DeleteItem(m_CurSelIndex);

		m_CurSelIndex = -1;
	}
}

void CDlgProgrammingPage::OnBnClickedBtnDeleteall()
{
	CString* pStr;
	for(int i = 0; i < m_ImageList.GetItemCount(); i++) {
		pStr = (CString*)m_ImageList.GetItemData(i);
		SAFE_DELETE(pStr);
		m_ImageList.DeleteItem(i);
	}

	m_CurSelIndex = -1;
	//m_ImageList.DeleteAllItems(); // ̰   ߱  ʿ䰡 .
}
