// DlgRectFixtureSetup.cpp :  Դϴ.
//

#include "stdafx.h"
#include "TestBase01.h"
#include "DlgRectFixtureSetup.h"
#include ".\dlgrectfixturesetup.h"


// CDlgRectFixtureSetup ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgRectFixtureSetup, CDialog)
CDlgRectFixtureSetup::CDlgRectFixtureSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgRectFixtureSetup::IDD, pParent)
	, m_RfsName(_T(""))
	, m_RfsHorPixels(0)
	, m_RfsVertPixels(0)
	, m_RfsSymWidth(0)
	, m_RfsSymHeight(0)
	, m_RfsTotalPixels(0)
	, m_RfsTotalWidth(0)
	, m_RfsTotalHeight(0)
{
	name = "none";
	horipixels = 1;
	vertpixels = 1;
	symbolwidth = 1;
	symbolheight = 1;
	totalpixels = 1;
	totalwidth = 1;
	totalheight = 1;

	modifymode = RECTANGLEMODE_ADD;
}

CDlgRectFixtureSetup::~CDlgRectFixtureSetup()
{
}

void CDlgRectFixtureSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_RFS_NAME, m_RfsName);
	DDX_Text(pDX, IDC_EDIT_RFS_HORPIXELS, m_RfsHorPixels);
	DDX_Text(pDX, IDC_EDIT_RFS_VERTPIXELS, m_RfsVertPixels);
	DDX_Text(pDX, IDC_EDIT_RFS_SYMWIDTH, m_RfsSymWidth);
	DDX_Text(pDX, IDC_EDIT_RFS_SYMHEIGHT, m_RfsSymHeight);
	DDX_Text(pDX, IDC_EDIT_RFS_TOTALPIXELS, m_RfsTotalPixels);
	DDX_Text(pDX, IDC_EDIT_RFS_TOTALWIDTH, m_RfsTotalWidth);
	DDX_Text(pDX, IDC_EDIT_RFS_TOTALHEIGHT, m_RfsTotalHeight);
}


BEGIN_MESSAGE_MAP(CDlgRectFixtureSetup, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BTN_RFS_COLOR, OnBnClickedBtnRfsColor)
	ON_BN_CLICKED(IDC_BTN_RFS_SCANORDER, OnBnClickedBtnRfsScanorder)
	ON_EN_CHANGE(IDC_EDIT_RFS_HORPIXELS, OnEnChangeEditRfsHorpixels)
	ON_EN_CHANGE(IDC_EDIT_RFS_VERTPIXELS, OnEnChangeEditRfsVertpixels)
END_MESSAGE_MAP()


// CDlgRectFixtureSetup ޽ óԴϴ.

BOOL CDlgRectFixtureSetup::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  Ų.
	m_RfsName			=name;
	m_RfsHorPixels		=horipixels;
	m_RfsVertPixels		=vertpixels;
	m_RfsSymWidth		=symbolwidth;
	m_RfsSymHeight		=symbolheight;
	m_RfsTotalPixels	=totalpixels;
	m_RfsTotalWidth		=totalwidth;
	m_RfsTotalHeight	=totalheight;
//						 color;
//						 scanorder;

	if(modifymode == RECTANGLEMODE_MODIFY) {
		//  . ̸ ٲܼ .
		GetDlgItem(IDC_EDIT_RFS_NAME)->EnableWindow(FALSE);
	}

	// ϴ κ HorizontalPixels, VerticalPixels Ѵ.
	//   ǵ Ѵ.
	GetDlgItem(IDC_EDIT_RFS_SYMWIDTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_RFS_SYMHEIGHT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_RFS_TOTALPIXELS)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_RFS_TOTALWIDTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_RFS_TOTALHEIGHT)->EnableWindow(FALSE);

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}
void CDlgRectFixtureSetup::OnBnClickedOk()
{
	//  Ʈ ϰ Ѱ ֱ ؼ  Ѵ.
	UpdateData();
	name = m_RfsName;
/*
	horipixels = m_RfsHorPixels;
	vertpixels = m_RfsVertPixels;
	symbolwidth = m_RfsSymWidth;
	symbolheight = m_RfsSymHeight;
	totalpixels = m_RfsTotalPixels;
	totalwidth = m_RfsTotalWidth;
	totalheight = m_RfsTotalHeight;
*/
	// ɷ ؾ  Ʒɷ 켱 ġȯ
	horipixels = m_RfsHorPixels;
	vertpixels = m_RfsVertPixels;
	symbolwidth = m_RfsHorPixels;
	symbolheight = m_RfsVertPixels;
	totalwidth = m_RfsHorPixels;
	totalheight = m_RfsVertPixels;
	totalpixels = totalwidth * totalheight;


	OnOK();
}

void CDlgRectFixtureSetup::OnBnClickedCancel()
{
	OnCancel();
}

void CDlgRectFixtureSetup::OnBnClickedBtnRfsColor()
{
	//Color
}

void CDlgRectFixtureSetup::OnBnClickedBtnRfsScanorder()
{
	// Scanorder
}

void CDlgRectFixtureSetup::OnEnChangeEditRfsHorpixels()
{
	// TODO:  RICHEDIT Ʈ   Ʈ
	// CDialog::ũ OR Ͽ  ENM_CHANGE ÷׸ Ͽ
	// CRichEditCtrl().SetEventMask() ȣϵ OnInitDialog() Լ  
	//  ˸  ʽϴ.

	UpdateData(TRUE);

	m_RfsTotalWidth = m_RfsSymWidth = m_RfsHorPixels;
//	m_RfsTotalHeight = m_RfsSymHeight = m_RfsVertPixels;
	m_RfsTotalPixels = m_RfsTotalWidth * m_RfsTotalHeight;

	UpdateData(FALSE);
}

void CDlgRectFixtureSetup::OnEnChangeEditRfsVertpixels()
{
	// TODO:  RICHEDIT Ʈ   Ʈ
	// CDialog::ũ OR Ͽ  ENM_CHANGE ÷׸ Ͽ
	// CRichEditCtrl().SetEventMask() ȣϵ OnInitDialog() Լ  
	//  ˸  ʽϴ.

	UpdateData(TRUE);

//	m_RfsTotalWidth = m_RfsSymWidth = m_RfsHorPixels;
	m_RfsTotalHeight = m_RfsSymHeight = m_RfsVertPixels;
	m_RfsTotalPixels = m_RfsTotalWidth * m_RfsTotalHeight;

	UpdateData(FALSE);
}
