#pragma once


/*
* ɺ ⺻                                                  
Type :  Rectangle, Line ΰ  Ѵ.
	   Ʒ ǥ  ΰ Ӽ ԵǴ  ְ,
	   Ե ʴ  ִ.
	   ---------------------------------------
	   Rectangle | Line
	   ---------------------------------------
	   Name					*		*
	   uid						*		*
	   Type					*		*
	   Horizontal Pixels		*
	   Vertical Pixels			*
	   Symbol Width			*
	   Symbol Height			*
	   Scan Order				*
	   Total Pixels			*		*
	   Total Width				*
	   Total Height			*
	   Length					*		*
	   Color					*		*
	   defaultSymbol			*		*
	   --------------------------------------
*/

// CDlgRectFixtureSetup ȭ Դϴ.

class CDlgRectFixtureSetup : public CDialog
{
	DECLARE_DYNAMIC(CDlgRectFixtureSetup)

public:
	CDlgRectFixtureSetup(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~CDlgRectFixtureSetup();

public:
	// Է ް Ѱ ֱ 
	//    Է ؾ ϴ Դϴ.
	// mfc Ʈ   ƴմϴ.
	CString			name;
	int				horipixels;
	int				vertpixels;
	int				symbolwidth;
	int				symbolheight;
	int				totalpixels;
	int				totalwidth;
	int				totalheight;
	DWORD			color;
	int				scanorder;

	enum RECTANGLEMODE_TYPE {	RECTANGLEMODE_ADD, RECTANGLEMODE_MODIFY };
	RECTANGLEMODE_TYPE	modifymode;

// ȭ  Դϴ.
	enum { IDD = IDD_DLG_RECTANGLEFIXTURESETUP };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

	DECLARE_MESSAGE_MAP()
public:
	CString m_RfsName;
	int m_RfsHorPixels;
	int m_RfsVertPixels;
	int m_RfsSymWidth;
	int m_RfsSymHeight;
	int m_RfsTotalPixels;
	int m_RfsTotalWidth;
	int m_RfsTotalHeight;
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedBtnRfsColor();
	afx_msg void OnBnClickedBtnRfsScanorder();
	afx_msg void OnEnChangeEditRfsHorpixels();
	afx_msg void OnEnChangeEditRfsVertpixels();
};
