// DlgSequencePage.cpp :  Դϴ.
//

#include "stdafx.h"
#include "TestBase01.h"
#include "DlgSequencePage.h"
#include ".\dlgsequencepage.h"


// CDlgSequencePage ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgSequencePage, CDialog)
CDlgSequencePage::CDlgSequencePage(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSequencePage::IDD, pParent)
{
	g_DlgSequencePage = this;
}

CDlgSequencePage::~CDlgSequencePage()
{
}

void CDlgSequencePage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SEQUENCE_LIST_INFO, m_listPortSequencePerAddress);
}


BEGIN_MESSAGE_MAP(CDlgSequencePage, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_WM_ERASEBKGND()
	ON_WM_DESTROY()
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_SEQUENCE_LIST_INFO, OnLvnItemchangedSequenceListInfo)
END_MESSAGE_MAP()


// CDlgSequencePage ޽ óԴϴ.

BOOL CDlgSequencePage::Create(CWnd* pParentWnd)
{
	return CDialog::Create(IDD, pParentWnd);
}

void CDlgSequencePage::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
//	OnOK();
}

void CDlgSequencePage::OnBnClickedCancel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
//	OnCancel();
}

BOOL CDlgSequencePage::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	return CDialog::OnEraseBkgnd(pDC);
}

void CDlgSequencePage::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}

BOOL CDlgSequencePage::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Ʈ Ʈ(Port/Sequence, Address)
	//  ÷  Ѵ.
	AddColumn();

	//   Ǵ · Ÿ ٲٱ
	m_listPortSequencePerAddress.SetExtendedStyle(LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT);

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

// Ʈ ÷ ߰Լ
void CDlgSequencePage::AddColumn()
{
	//÷ ä
	int m_nColWidths[] = { 90, 60};	// sixty-fourths
	TCHAR *	lpszHeaders[] = {
								_T("Port/Sequence"),
								_T("Address"),
								NULL };

	int i;
	LV_COLUMN lvcolumn;
	memset(&lvcolumn, 0, sizeof(lvcolumn));

	// add columns
	for (i = 0; ; i++) {
		if (lpszHeaders[i] == NULL)
			break;

		lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
		lvcolumn.fmt = LVCFMT_LEFT;
		lvcolumn.pszText = lpszHeaders[i];
		lvcolumn.iSubItem = i;
		lvcolumn.cx = m_nColWidths[i];
		m_listPortSequencePerAddress.InsertColumn(i, &lvcolumn);
	}
}

// ÷   
void CDlgSequencePage::DeleteAll()
{
	m_listPortSequencePerAddress.DeleteAllItems();
}

// ÷  ߰ϱ
void CDlgSequencePage::AddData(CString portName, int Address, lpFixtureElement pFixEle)
{
	CString strText;
	int index = 0;
	index = m_listPortSequencePerAddress.GetItemCount();

	// Insert the item, select every other item.
	strText = portName;
	int id = m_listPortSequencePerAddress.InsertItem(LVIF_TEXT|LVIF_PARAM, index, strText, 0, 0, 0, (LPARAM)pFixEle);

	// Insert 10 items in the list view control.
	strText.Format(TEXT("%d"), Address);
	m_listPortSequencePerAddress.SetItemText(index, 1, strText);	
}

void CDlgSequencePage::OnLvnItemchangedSequenceListInfo(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	static int oldSelectItemLine = -1;

	// ش  ȣ ׻ 3 ȣǰ ٸ ȣ  
	// ⼭ ɷ ش.
	if(pNMLV->iItem != oldSelectItemLine) {
		oldSelectItemLine = pNMLV->iItem;

		// Ʈ Ʈѿ    ؼ
		//  .
		lpFixtureElement pFixEle = (lpFixtureElement)m_listPortSequencePerAddress.GetItemData(pNMLV->iItem);
		ASSERT(pFixEle);
		FixtureArray::GetInstance().ChangedFixtureElement(pFixEle);

		// PixelMap View ȭ Ʈ Ѵ.
		g_PixelMapView->Invalidate();
	}

	*pResult = 0;
}
