// PixelMapView.cpp :  Դϴ.
//

#include "stdafx.h"
#include "DlgPixelMapPage.h"
#include "PixelMapView.h"
#include ".\pixelmapview.h"

//#include "GsiScrollView01Dlg.h"

//extern CGsiScrollView01Dlg* g_pScrollViewDlg;

//
//IMPLEMENT_DYNCREATE(CDummyDoc, CDocument)

// CPixelMapView

IMPLEMENT_DYNCREATE(CPixelMapView, CZoomView)

CPixelMapView::CPixelMapView()
{
	g_PixelMapView = this;

	m_ScaleValue = 0.f;
	m_MousePos = CPoint(0, 0);
	m_MousePosToGrid = CPoint(0, 0);

	oldGridPoint = CPoint(0, 0);
}

CPixelMapView::~CPixelMapView()
{
}


BEGIN_MESSAGE_MAP(CPixelMapView, CZoomView)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
END_MESSAGE_MAP()


// CPixelMapView ׸Դϴ.

void CPixelMapView::OnInitialUpdate()
{
	CZoomView::OnInitialUpdate();

	// 	CSize sizeTotal;
	// 	// TODO:   ü ũ⸦ մϴ.
	// 	sizeTotal.cx = sizeTotal.cy = 100;
	// 	SetScrollSizes(MM_TEXT, sizeTotal);

	// Initialize the CZoomView class
	SetZoomSizes(CSize(1024*PIXEL_PER_SIZE,1024*PIXEL_PER_SIZE));
}

void CPixelMapView::OnDraw(CDC* pDC)
{
	//	CDocument* pDoc = GetDocument();

	// 
	DrawBackground(pDC);

	// 
	DrawItem(pDC);

	// ׸
	DrawGrid(pDC);
}


// CPixelMapView Դϴ.

#ifdef _DEBUG
void CPixelMapView::AssertValid() const
{
	CZoomView::AssertValid();
}

void CPixelMapView::Dump(CDumpContext& dc) const
{
	CZoomView::Dump(dc);
}
#endif //_DEBUG


// CPixelMapView ޽ óԴϴ.

BOOL CPixelMapView::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
	//	return CZoomView::OnEraseBkgnd(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CTestView message handlers
//
/*---------------------------------------------------------------------------
FUNCTION: OnViewZoomin
PURPOSE : User pressed the ZOOM IN toolbutton or menu
---------------------------------------------------------------------------*/
void CPixelMapView::OnViewZoomin()
{
	// Toggle zoomin mode
	CWnd *pWin = ((CWinApp *) AfxGetApp())->m_pMainWnd;
	if (GetZoomMode() == MODE_ZOOMIN) {
		SetZoomMode(MODE_ZOOMOFF);
		// Clear the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"");
	} else {
		SetZoomMode(MODE_ZOOMIN);
		// Give instructions in the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"Click to zoom in on point or drag a zoom box.");
	}
} // OnViewZoomin

/*---------------------------------------------------------------------------
FUNCTION: OnViewZoomout
PURPOSE : User pressed the ZOOM OUT toolbutton or menu
---------------------------------------------------------------------------*/
void CPixelMapView::OnViewZoomout()
{
	// Toggle zoomout mode
	CWnd *pWin = ((CWinApp *) AfxGetApp())->m_pMainWnd;
	if (GetZoomMode() == MODE_ZOOMOUT) {
		SetZoomMode(MODE_ZOOMOFF);
		// Clear the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"");
	} else {
		SetZoomMode(MODE_ZOOMOUT);
		// Give instructions in the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"Click to zoom out on point.");
	}
} // OnViewZoomout

/*---------------------------------------------------------------------------
FUNCTION: OnViewZoomfull
PURPOSE : User pressed the ZOOM FULL toolbutton or menu
---------------------------------------------------------------------------*/
void CPixelMapView::OnViewZoomfull()
{
	DoZoomFull();  // Call CZoomView member to zoom full scale
} // OnViewZoomfull

// 
void CPixelMapView::DrawBackground(CDC* pDC)
{
	CBrush *oldBrush;
	CBrush brush;
	brush.CreateSolidBrush(COLOR_GBACKGROUND);
	oldBrush = pDC->SelectObject(&brush);

	CRect rect(0, 0, m_totalLog.cx, m_totalLog.cy);
	pDC->Rectangle(&rect);

	pDC->SelectObject(oldBrush);
}

// ׸
void CPixelMapView::DrawGrid(CDC* pDC)
{
	CPen     *oldPen;

	//	pDC->SetBkMode(TRANSPARENT);

	CPen newPen(PS_SOLID, 1, COLOR_GRIDLINE); // 0 width = 1 device unit
	oldPen = pDC->SelectObject(&newPen);

	int width  = m_totalLog.cx / PIXEL_PER_SIZE;
	int height = m_totalLog.cy / PIXEL_PER_SIZE;

	CPoint pstart = CPoint(0, 0);
	CPoint pend = CPoint(0, height*PIXEL_PER_SIZE);

	//   ɵ..
	for (int col = 0; col < width; col++) {
		pstart.x += PIXEL_PER_SIZE;
		pend.x += PIXEL_PER_SIZE;
		pDC->MoveTo(pstart);
		pDC->LineTo(pend);
	}

	pstart = CPoint(0, 0);
	pend = CPoint(width*PIXEL_PER_SIZE, 0);
	for (int row = 0; row < height; row++) {
		pstart.y += PIXEL_PER_SIZE;
		pend.y += PIXEL_PER_SIZE;
		pDC->MoveTo(pstart);
		pDC->LineTo(pend);
	}

	//  
	pstart = CPoint(0, 0);
	pend = CPoint(0, height*PIXEL_PER_SIZE);
	for (int col = 0; col < width; col++) {
		if(col == 0 || col % 10 == 0) {
			CString str;
			str.Format("%d", col);
			pDC->TextOut(pstart.x, 10, str);
		}

		pstart.x += PIXEL_PER_SIZE;
		pend.x += PIXEL_PER_SIZE;
	}

	pstart = CPoint(0, 0);
	pend = CPoint(width*PIXEL_PER_SIZE, 0);
	for (int row = 0; row < height; row++) {
		if(row == 0 || row % 10 == 0) {
			CString str;
			str.Format("%d", row);
			pDC->TextOut(10, pstart.y, str);
		}

		pstart.y += PIXEL_PER_SIZE;
		pend.y += PIXEL_PER_SIZE;
	}

	pDC->SelectObject(oldPen);
}

// 
void CPixelMapView::DrawItem(CDC* pDC)
{
	FixtureArray::GetInstance().Draw(pDC);
}

// 콺 ġ ޾Ƽ Grid ϴ 
CPoint CPixelMapView::GetGrid(CPoint point)
{
	m_ScaleValue = GetZoomScale();
	m_MousePos = point;
	m_MousePos += GetScrollPosition();
	m_MousePosToGrid = CPoint(m_MousePos.x / PIXEL_PER_SIZE, m_MousePos.y / PIXEL_PER_SIZE);
	m_MousePosToScaleGrid = CPoint((int)((float)m_MousePosToGrid.x / m_ScaleValue), (int)((float)m_MousePosToGrid.y / m_ScaleValue));

	return m_MousePosToScaleGrid;
}

void CPixelMapView::OnLButtonDown(UINT nFlags, CPoint point)
{
	CZoomView::OnLButtonDown(nFlags, point);

	if(GetZoomMode() == MODE_ZOOMOFF) {

		// ߰ ϶...
		if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_PAN) {
		}
		else if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_MOVE) {
		}
		else if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_ADD) {
		}
		else if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_SELECT) {
		}
	}
}

void CPixelMapView::OnMouseMove(UINT nFlags, CPoint point)
{
	CZoomView::OnMouseMove(nFlags, point);

	//ȭ 尡   ⸦ ó ϸ ȵȴ.
	if(GetZoomMode() == MODE_ZOOMOFF && m_nMapMode == MM_ANISOTROPIC) {

		// ߰ ϶...
		if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_PAN) {
		}
		else if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_MOVE) {
		}
		else if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_ADD) {
			CClientDC dc(this);

			//
			CPoint newGridPoint;

			m_ScaleValue = GetZoomScale();
			m_MousePos = point;
			m_MousePosToGrid = CPoint(m_MousePos.x / PIXEL_PER_SIZE, m_MousePos.y / PIXEL_PER_SIZE);
			newGridPoint = CPoint((int)((float)m_MousePosToGrid.x / m_ScaleValue), (int)((float)m_MousePosToGrid.y / m_ScaleValue));

			CPoint pos;
			pos = CPoint(oldGridPoint.x * PIXEL_PER_SIZE, oldGridPoint.y * PIXEL_PER_SIZE);
			SymbolArray::GetInstance().DrawMoveEffect(dc, pos);
			oldGridPoint = newGridPoint;
			pos = CPoint(oldGridPoint.x * PIXEL_PER_SIZE, oldGridPoint.y * PIXEL_PER_SIZE);

			SymbolArray::GetInstance().DrawMoveEffect(dc, pos);
		}
		else if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_SELECT) {
		}

		return;
	}
}

void CPixelMapView::OnLButtonUp(UINT nFlags, CPoint point)
{
	//ȭ 尡   ⸦ ó ϸ ȵȴ.
	if(GetZoomMode() == MODE_ZOOMOFF && m_nMapMode == MM_ANISOTROPIC) {

		// ߰ ϶...
		if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_PAN) {
		}
		else if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_MOVE) {
		}
		else if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_ADD) {
			CClientDC dc(this);
			OnPrepareDC(&dc);

			CPoint pos;
			m_ScaleValue = GetZoomScale();
			m_MousePos = point;
			m_MousePosToGrid = CPoint(m_MousePos.x / PIXEL_PER_SIZE, m_MousePos.y / PIXEL_PER_SIZE);
			pos = CPoint((int)((float)m_MousePosToGrid.x / m_ScaleValue), (int)((float)m_MousePosToGrid.y / m_ScaleValue));
			SymbolArray::GetInstance().DrawMoveEffect(dc, pos);

			// Fixture Element ߰
			CPoint newGridPoint = GetGrid(point);
			// ش ġ  Ѵ.
			FixtureArray::GetInstance().AddFixture(newGridPoint.x, newGridPoint.y);

			// ȭ 
			g_DlgPixelMapPage->Invalidate();
		}
		else if(g_MainFrm->GetPixelmapToolBoxSwitchMode() == PALETTE_PM_TB_SELECT) {
			// Fixture Element ߰
			CPoint newGridPoint = GetGrid(point);
			// ش ġ ִ Fixture ŽѴ.
			if(FixtureArray::GetInstance().FindFixture(newGridPoint.x, newGridPoint.y)) {
				//
				TRACE("Select Fixture\n");
				g_PixelMapView->Invalidate();
			}
		}

		return;
	}

	CZoomView::OnLButtonUp(nFlags, point);
}
