// TestBase01View.cpp : CTestBase01View Ŭ 
//

#include "stdafx.h"
#include "TestBase01.h"

#include "TestBase01Doc.h"
#include "TestBase01View.h"
#include ".\testbase01view.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTestBase01View

IMPLEMENT_DYNCREATE(CTestBase01View, CFormView)

BEGIN_MESSAGE_MAP(CTestBase01View, CFormView)
	ON_WM_SIZE()
	ON_NOTIFY(NM_CLICK, IDC_TB_MAIN, OnNMClickTbMain)
END_MESSAGE_MAP()

// CTestBase01View /Ҹ

CTestBase01View::CTestBase01View()
	: CFormView(CTestBase01View::IDD)
{
	// TODO: ⿡  ڵ带 ߰մϴ.

	g_TestBase01View = this;
}

CTestBase01View::~CTestBase01View()
{
}

void CTestBase01View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TB_MAIN, m_tbMain);
}

BOOL CTestBase01View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	return CFormView::PreCreateWindow(cs);
}

void CTestBase01View::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	//   Ӽ ߰
	AddTabMain();

	//   Ʈ  
	ResizeTabMain();
}


// CTestBase01View 

#ifdef _DEBUG
void CTestBase01View::AssertValid() const
{
	CFormView::AssertValid();
}

void CTestBase01View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CTestBase01Doc* CTestBase01View::GetDocument() const // ׵   ζ ˴ϴ.
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestBase01Doc)));
	return (CTestBase01Doc*)m_pDocument;
}
#endif //_DEBUG


// CTestBase01View ޽ ó

void CTestBase01View::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);

	//   Ʈ  
	ResizeTabMain();
}

//   Ӽ ߰
void CTestBase01View::AddTabMain()
{
	//  ߰
	TABCTRL_AUTOINPUT_INSERTITEM(m_tbMain, tab_MainHeadersName);
	m_tbMain.SetCurSel(PALETTE_PIXELMAP);

	ShowPixelMapPage(TRUE);
}

//   Ʈ  
void CTestBase01View::ResizeTabMain()
{
	CHECK_CREATEDLG(m_tbMain);

	CRect rect;
	GetClientRect(&rect);

	m_tbMain.MoveWindow(&rect);

	//  ϸ  Ʈ ġ ؾ Ѵ.
	GetResizeSubDlg(&m_PixelMapPage);
	GetResizeSubDlg(&m_ProgrammingPage);
}

// ȭ 
void CTestBase01View::GetResizeSubDlg(CDialog* pDlg)
{
	CHECK_CREATEDLG((*pDlg));

	CRect rect;
	m_tbMain.GetClientRect(&rect);

	pDlg->SetWindowPos(NULL, 2, 24, rect.right-6, rect.bottom-28, SWP_FRAMECHANGED);
}

// ȭ 
void CTestBase01View::ShowPixelMapPage(BOOL isShow)
{
	if(isShow)
	{
		if(m_PixelMapPage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_PixelMapPage.ShowWindow(SW_SHOW);
			m_PixelMapPage.SetFocus();
			GetResizeSubDlg(&m_PixelMapPage);
		}
		else //̾α ڽ µǾ   
		{
			m_PixelMapPage.Create((CWnd*)&m_tbMain);
			m_PixelMapPage.ShowWindow(SW_SHOW);
			GetResizeSubDlg(&m_PixelMapPage);
			//m_PixelMapPage.SetWindowPos(NULL, 2, 24, 100, 100, SWP_NOSIZE);
		}
	}
	else
	{
		if(m_PixelMapPage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_PixelMapPage.ShowWindow(SW_HIDE);
		}
	}
}

// ȭ 
void CTestBase01View::ShowProgrammingPage(BOOL isShow)
{
	if(isShow)
	{
		if(m_ProgrammingPage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_ProgrammingPage.ShowWindow(SW_SHOW);
			m_ProgrammingPage.SetFocus();
		}
		else //̾α ڽ µǾ   
		{
			m_ProgrammingPage.Create((CWnd*)&m_tbMain);
			m_ProgrammingPage.ShowWindow(SW_SHOW);
			GetResizeSubDlg(&m_ProgrammingPage);
			//m_SequencePage.SetWindowPos(NULL, 2, 24, 100, 100, SWP_NOSIZE);
		}
	}
	else
	{
		if(m_ProgrammingPage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_ProgrammingPage.ShowWindow(SW_HIDE);
		}
	}
}

void CTestBase01View::OnNMClickTbMain(NMHDR *pNMHDR, LRESULT *pResult)
{
	switch(m_tbMain.GetCurSel())
	{
	case PALETTE_PIXELMAP:
		ShowProgrammingPage(FALSE);
		ShowPixelMapPage(TRUE);
		break;

	case PALETTE_SEQUENCE:
		ShowPixelMapPage(FALSE);
		ShowProgrammingPage(TRUE);
		break;
	}

	*pResult = 0;
}
