// DlgPixelMapPage.cpp :  Դϴ.
//

#include "stdafx.h"
#include "TestBase01.h"
#include "DlgPixelMapPage.h"
#include ".\dlgpixelmappage.h"


// PIXEL MAP    Ʈ 
#define LOCK_SIZE_PIXELMAP_SUBTAB	200
// PIXEL MAP ֺ  Ʈ ü (X )
#define LOCK_SIZE_PIXELMAP_MARGIN_VSIZE	6
// PIXEL MAP ֺ  Ʈ ü (Y )
#define LOCK_SIZE_PIXELMAP_MARGIN_HSIZE	6
// PIXEL MAP  Ʈ  ũ
#define LOCK_SIZE_PIXELMAP_SUBTOOLBOX	100


// CDlgPixelMapPage ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgPixelMapPage, CDialog)
CDlgPixelMapPage::CDlgPixelMapPage(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPixelMapPage::IDD, pParent)
{
	g_DlgPixelMapPage = this;
}

CDlgPixelMapPage::~CDlgPixelMapPage()
{
}

void CDlgPixelMapPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PIXELMAP_TB_SUBFORM, m_tbPixelMapSubForm);
}


BEGIN_MESSAGE_MAP(CDlgPixelMapPage, CDialog)
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_WM_NCDESTROY()
	ON_WM_DESTROY()
	ON_NOTIFY(NM_CLICK, IDC_PIXELMAP_TB_SUBFORM, OnNMClickPixelmapTbSubform)
END_MESSAGE_MAP()


// CDlgPixelMapPage ޽ óԴϴ.

void CDlgPixelMapPage::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	//	OnOK();
}

void CDlgPixelMapPage::OnBnClickedCancel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	//	OnCancel();
}

BOOL CDlgPixelMapPage::Create(CWnd* pParentWnd)
{
	return CDialog::Create(IDD, pParentWnd);
}

BOOL CDlgPixelMapPage::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	return TRUE;
//	return CDialog::OnEraseBkgnd(pDC);
}

BOOL CDlgPixelMapPage::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ڽ Ʈ 
	m_PixelMapToolBox.Create(this);
	m_PixelMapToolBox.ShowWindow(SW_SHOW);

	// PixelMap  
	CCreateContext pContext;
	CWnd* pFrameWnd = this;

	pContext.m_pCurrentDoc = new CDummyDoc();
	pContext.m_pNewViewClass = RUNTIME_CLASS(CPixelMapView);
	m_pPixelMapView = (CPixelMapView *) ((CFrameWnd*)pFrameWnd)->CreateView(&pContext);
	ASSERT(m_pPixelMapView);
	m_pPixelMapView->ShowWindow(SW_NORMAL);

	//   Ӽ ߰
	AddTabMain();

	//   Ʈ  
	ResizeTabMain();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CDlgPixelMapPage::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	//   Ʈ  
	ResizeTabMain();
}

//   Ӽ ߰
void CDlgPixelMapPage::AddTabMain()
{
	//  ߰
	TABCTRL_AUTOINPUT_INSERTITEM(m_tbPixelMapSubForm, tab_PixelMapSubHeadersName);
	m_tbPixelMapSubForm.SetCurSel(PALETTE_PM_FIXTUREINFO);

	ShowFixturePage(TRUE);
}

//   Ʈ  
void CDlgPixelMapPage::ResizeTabMain()
{
	CHECK_CREATEDLG(m_tbPixelMapSubForm);

	CRect rect, rect2, rect3;
	GetClientRect(&rect);
	rect2 = rect;

	//  
	//   Ǿ ִ.
	// Ʒ ũ  ٲ Ѵ.
	rect.right = LOCK_SIZE_PIXELMAP_SUBTAB;
	m_tbPixelMapSubForm.MoveWindow(&rect);

	// ʿ ٴ  ڽ Ʈ
	// ġ 
	rect2.left = LOCK_SIZE_PIXELMAP_SUBTAB + LOCK_SIZE_PIXELMAP_MARGIN_VSIZE;
	m_PixelMapToolBox.SetWindowPos(NULL, rect2.left, LOCK_SIZE_PIXELMAP_MARGIN_HSIZE, rect2.right - rect2.left, LOCK_SIZE_PIXELMAP_SUBTOOLBOX, SWP_FRAMECHANGED);

	//  ϴܿ ٴ  ڽ Ʈ
	rect3 = rect2;
	rect3.top = LOCK_SIZE_PIXELMAP_MARGIN_HSIZE * 2 + LOCK_SIZE_PIXELMAP_SUBTOOLBOX;
	m_pPixelMapView->SetWindowPos(NULL, rect3.left, rect3.top, rect3.right - rect3.left, rect3.bottom - rect3.top, SWP_FRAMECHANGED);

	//  ϸ  Ʈ ġ ؾ Ѵ.
	GetResizeSubDlg(&m_FixturePage);
	GetResizeSubDlg(&m_SequencePage);
}

void CDlgPixelMapPage::OnNcDestroy()
{
	CDialog::OnNcDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}

void CDlgPixelMapPage::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}

// ȭ 
void CDlgPixelMapPage::GetResizeSubDlg(CDialog* pDlg)
{
	CHECK_CREATEDLG((*pDlg));

	CRect rect;
	m_tbPixelMapSubForm.GetClientRect(&rect);

	pDlg->SetWindowPos(NULL, 2, 24, rect.right-6, rect.bottom-28, SWP_FRAMECHANGED);
}

// ȭ 
void CDlgPixelMapPage::ShowFixturePage(BOOL isShow)
{
	if(isShow)
	{
		if(m_FixturePage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_FixturePage.ShowWindow(SW_SHOW);
			m_FixturePage.SetFocus();
			GetResizeSubDlg(&m_FixturePage);
		}
		else //̾α ڽ µǾ   
		{
			m_FixturePage.Create((CWnd*)&m_tbPixelMapSubForm);
			m_FixturePage.ShowWindow(SW_SHOW);
			GetResizeSubDlg(&m_FixturePage);
			//m_FixturePage.SetWindowPos(NULL, 2, 24, 100, 100, SWP_NOSIZE);
		}
	}
	else
	{
		if(m_FixturePage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_FixturePage.ShowWindow(SW_HIDE);
		}
	}
}

// ȭ 
void CDlgPixelMapPage::ShowSequencePage(BOOL isShow)
{
	if(isShow)
	{
		if(m_SequencePage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_SequencePage.ShowWindow(SW_SHOW);
			m_SequencePage.SetFocus();
		}
		else //̾α ڽ µǾ   
		{
			m_SequencePage.Create((CWnd*)&m_tbPixelMapSubForm);
			m_SequencePage.ShowWindow(SW_SHOW);
			GetResizeSubDlg(&m_SequencePage);
			//m_SequencePage.SetWindowPos(NULL, 2, 24, 100, 100, SWP_NOSIZE);
		}
	}
	else
	{
		if(m_SequencePage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_SequencePage.ShowWindow(SW_HIDE);
		}
	}
}

// ȭ 
void CDlgPixelMapPage::ShowPixelListPage(BOOL isShow)
{
	if(isShow)
	{
		if(m_PixelListPage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_PixelListPage.ShowWindow(SW_SHOW);
			m_PixelListPage.SetFocus();
			GetResizeSubDlg(&m_PixelListPage);
		}
		else //̾α ڽ µǾ   
		{
			m_PixelListPage.Create((CWnd*)&m_tbPixelMapSubForm);
			m_PixelListPage.ShowWindow(SW_SHOW);
			GetResizeSubDlg(&m_PixelListPage);
			//m_PixelListPage.SetWindowPos(NULL, 2, 24, 100, 100, SWP_NOSIZE);
		}
	}
	else
	{
		if(m_PixelListPage.GetSafeHwnd() != NULL) // ̾α ڽ µǾ  
		{
			m_PixelListPage.ShowWindow(SW_HIDE);
		}
	}
}

void CDlgPixelMapPage::OnNMClickPixelmapTbSubform(NMHDR *pNMHDR, LRESULT *pResult)
{
	switch(m_tbPixelMapSubForm.GetCurSel())
	{
	case PALETTE_PM_FIXTUREINFO:
		ShowPixelListPage(FALSE);
		ShowSequencePage(FALSE);
		ShowFixturePage(TRUE);
		break;

	case PALETTE_PM_SEQUENCE:
		ShowPixelListPage(FALSE);
		ShowFixturePage(FALSE);
		ShowSequencePage(TRUE);
		break;

	case PALETTE_PM_PIXELLIST:
		ShowFixturePage(FALSE);
		ShowSequencePage(FALSE);
		ShowPixelListPage(TRUE);
		break;
	}

	// ٲ  Ʈ ־ Ѵ.
	FixtureArray::GetInstance().UpdatePixelMapInfo();

	*pResult = 0;
}
