#pragma once

//////////////////////////////////////////////////////////////////////////
// FixtureElement
/*
* ȭ鿡   
*/

class FixtureElement
{
public:
	FixtureElement() {

	}
	virtual ~FixtureElement() {}

	//
	int				uid;		//  ̵
	int				x;			// x  ε
	int				y;			// y  ε
	int				symbolUid;	// SymbolBase  ̵
};
typedef FixtureElement*				lpFixtureElement;
typedef FixtureElement&				refFixtureElement;
typedef vector<lpFixtureElement>	vFixtureElement;
typedef vFixtureElement::iterator	vFixtureElementIter;

//////////////////////////////////////////////////////////////////////////
// CFixtureArray
/*
* ȭ鿡   迭 Ѵ.
*/
class FixtureArray
{
	FixtureArray(void);
public:
	static FixtureArray& GetInstance()
	{
		static FixtureArray fix;
		return fix;
	}
	~FixtureArray(void);

	// ߰
	void AddFixture(int xIndex, int yIndex);
	// Ž
	bool FindFixture(int xIndex, int yIndex);
	// 
	bool DeleteFixture(lpFixtureElement pFixture);
	void DeleteAllFixture();
	// (ߺüũ)
	bool IsOverapFixture(int xindex, int yindex);

	// õ FixtureElement
	lpFixtureElement GetFixtureElement();

	// Draw
	void Draw(CDC* pDC);

	// Current Selected ChangeFixtureElement
	void UpdatePixelMapInfo();

	// õ Fixture oriX  ̵Ų.
	bool CurChangeFixturePosX(bool bup);
	// õ Fixture oriY  ̵Ų.
	bool CurChangeFixturePosY(bool bup);

	// ٸ  FuxtureElement     ȣѴ.
	void ChangedFixtureElement(lpFixtureElement pFixEle);

protected:
	// ߰
	void AddFixture(lpFixtureElement pFixture);
	// Draw
	void DrawSelectFixture(CDC* pDC);

public:
	// ȭ ü 迭
	vFixtureElement				m_vFixtureElementList;

	// UID ο   -  
	int							m_RefUid;

	//  õ FixtureElement 
	lpFixtureElement m_pcurFixtureElement;
};
