// PixelMapView.cpp :  Դϴ.
//

#include "stdafx.h"
#include "DlgPixelMapPage.h"
#include "PixelMapView.h"
#include ".\programmingview.h"

//#include "GsiScrollView01Dlg.h"

//extern CGsiScrollView01Dlg* g_pScrollViewDlg;

// CProgrammingView

IMPLEMENT_DYNCREATE(CProgrammingView, CZoomView)

CProgrammingView::CProgrammingView()
{
	g_ProgrammingView = this;

	m_ScaleValue = 0.f;
	m_MousePos = CPoint(0, 0);
	m_MousePosToGrid = CPoint(0, 0);

	oldGridPoint = CPoint(0, 0);
}

CProgrammingView::~CProgrammingView()
{
	SAFE_DELETE(m_pImage);
}


BEGIN_MESSAGE_MAP(CProgrammingView, CZoomView)
END_MESSAGE_MAP()


// CProgrammingView ׸Դϴ.

void CProgrammingView::OnInitialUpdate()
{
	CZoomView::OnInitialUpdate();

	m_pImage = NULL;

	// 	CSize sizeTotal;
	// 	// TODO:   ü ũ⸦ մϴ.
	// 	sizeTotal.cx = sizeTotal.cy = 100;
	// 	SetScrollSizes(MM_TEXT, sizeTotal);

	// Initialize the CZoomView class
	SetZoomSizes(CSize(1024*PIXEL_PER_SIZE,1024*PIXEL_PER_SIZE));
}

void CProgrammingView::OnDraw(CDC* pDC)
{
	//	CDocument* pDoc = GetDocument();

	// 
	DrawBackground(pDC);
	// ׸
	DrawGrid(pDC);
	// 
	DrawItem(pDC);

	return;

	// ̹ εǾٸ ⼭  .
	if(m_pImage) {
//		int oldMode = GetMapMode(pDC->m_hDC);
//		SetMapMode(pDC->m_hDC, MM_ANISOTROPIC);

		// ̹  5 ؼ о Ҵ.
//		CSize sizeTotal;
//		sizeTotal.cx = m_pImage->GetWidth() * 5;
//		sizeTotal.cy = m_pImage->GetHeight() * 5;
//		SetScrollSizes(MM_TEXT, sizeTotal);

		// ũ  5   ߰Ѵ.
		m_pImage->Draw(pDC->m_hDC, 0, 0, m_pImage->GetWidth() * PIXEL_PER_SIZE, m_pImage->GetHeight() * PIXEL_PER_SIZE);

//		SetMapMode(pDC->m_hDC, MM_ANISOTROPIC);
//		SetMapMode(pDC->m_hDC, oldMode);
	}
}

// ̹ ü  ´.
void CProgrammingView::SetImage(CxImage* pImg)
{
	SAFE_DELETE(m_pImage);
	m_pImage = pImg;
	Invalidate();
}

// CProgrammingView Դϴ.

#ifdef _DEBUG
void CProgrammingView::AssertValid() const
{
	CZoomView::AssertValid();
}

void CProgrammingView::Dump(CDumpContext& dc) const
{
	CZoomView::Dump(dc);
}
#endif //_DEBUG


// CProgrammingView ޽ óԴϴ.

BOOL CProgrammingView::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
	//	return CZoomView::OnEraseBkgnd(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CTestView message handlers
//
/*---------------------------------------------------------------------------
FUNCTION: OnViewZoomin
PURPOSE : User pressed the ZOOM IN toolbutton or menu
---------------------------------------------------------------------------*/
void CProgrammingView::OnViewZoomin()
{
	// Toggle zoomin mode
	CWnd *pWin = ((CWinApp *) AfxGetApp())->m_pMainWnd;
	if (GetZoomMode() == MODE_ZOOMIN) {
		SetZoomMode(MODE_ZOOMOFF);
		// Clear the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"");
	} else {
		SetZoomMode(MODE_ZOOMIN);
		// Give instructions in the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"Click to zoom in on point or drag a zoom box.");
	}
} // OnViewZoomin

/*---------------------------------------------------------------------------
FUNCTION: OnViewZoomout
PURPOSE : User pressed the ZOOM OUT toolbutton or menu
---------------------------------------------------------------------------*/
void CProgrammingView::OnViewZoomout()
{
	// Toggle zoomout mode
	CWnd *pWin = ((CWinApp *) AfxGetApp())->m_pMainWnd;
	if (GetZoomMode() == MODE_ZOOMOUT) {
		SetZoomMode(MODE_ZOOMOFF);
		// Clear the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"");
	} else {
		SetZoomMode(MODE_ZOOMOUT);
		// Give instructions in the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"Click to zoom out on point.");
	}
} // OnViewZoomout

/*---------------------------------------------------------------------------
FUNCTION: OnViewZoomfull
PURPOSE : User pressed the ZOOM FULL toolbutton or menu
---------------------------------------------------------------------------*/
void CProgrammingView::OnViewZoomfull()
{
	DoZoomFull();  // Call CZoomView member to zoom full scale
} // OnViewZoomfull

// 
void CProgrammingView::DrawBackground(CDC* pDC)
{
	CBrush *oldBrush;
	CBrush brush;
	brush.CreateSolidBrush(COLOR_GBACKGROUND);
	oldBrush = pDC->SelectObject(&brush);

	CRect rect(0, 0, m_totalLog.cx, m_totalLog.cy);
	pDC->Rectangle(&rect);

	pDC->SelectObject(oldBrush);
}

// ׸
void CProgrammingView::DrawGrid(CDC* pDC)
{
	CPen     *oldPen;

	//	pDC->SetBkMode(TRANSPARENT);

	CPen newPen(PS_SOLID, 1, COLOR_GRIDLINE); // 0 width = 1 device unit
	oldPen = pDC->SelectObject(&newPen);

	int width  = m_totalLog.cx / PIXEL_PER_SIZE;
	int height = m_totalLog.cy / PIXEL_PER_SIZE;

	CPoint pstart = CPoint(0, 0);
	CPoint pend = CPoint(0, height*PIXEL_PER_SIZE);

	//   ɵ..
	for (int col = 0; col < width; col++) {
		pstart.x += PIXEL_PER_SIZE;
		pend.x += PIXEL_PER_SIZE;
		pDC->MoveTo(pstart);
		pDC->LineTo(pend);
	}

	pstart = CPoint(0, 0);
	pend = CPoint(width*PIXEL_PER_SIZE, 0);
	for (int row = 0; row < height; row++) {
		pstart.y += PIXEL_PER_SIZE;
		pend.y += PIXEL_PER_SIZE;
		pDC->MoveTo(pstart);
		pDC->LineTo(pend);
	}

	//  
	pstart = CPoint(0, 0);
	pend = CPoint(0, height*PIXEL_PER_SIZE);
	for (int col = 0; col < width; col++) {
		if(col == 0 || col % 10 == 0) {
			CString str;
			str.Format("%d", col);
			pDC->TextOut(pstart.x, 10, str);
		}

		pstart.x += PIXEL_PER_SIZE;
		pend.x += PIXEL_PER_SIZE;
	}

	pstart = CPoint(0, 0);
	pend = CPoint(width*PIXEL_PER_SIZE, 0);
	for (int row = 0; row < height; row++) {
		if(row == 0 || row % 10 == 0) {
			CString str;
			str.Format("%d", row);
			pDC->TextOut(10, pstart.y, str);
		}

		pstart.y += PIXEL_PER_SIZE;
		pend.y += PIXEL_PER_SIZE;
	}

	pDC->SelectObject(oldPen);
}

// 
void CProgrammingView::DrawItem(CDC* pDC)
{
	FixtureArray::GetInstance().Draw(pDC);
}

// 콺 ġ ޾Ƽ Grid ϴ 
CPoint CProgrammingView::GetGrid(CPoint point)
{
	m_ScaleValue = GetZoomScale();
	m_MousePos = point;
	m_MousePos += GetScrollPosition();
	m_MousePosToGrid = CPoint(m_MousePos.x / PIXEL_PER_SIZE, m_MousePos.y / PIXEL_PER_SIZE);
	m_MousePosToScaleGrid = CPoint((int)((float)m_MousePosToGrid.x / m_ScaleValue), (int)((float)m_MousePosToGrid.y / m_ScaleValue));

	return m_MousePosToScaleGrid;
}
